<?php
namespace Incoviba\Service\Venta;

use DateTimeImmutable;
use Incoviba\Common\Ideal\Service;
use Incoviba\Repository;
use Incoviba\Model;
use Incoviba\Service\Money;
use Psr\Log\LoggerInterface;

class Credito extends Service
{
    public function __construct(
        LoggerInterface $logger,
        protected Repository\Venta\Credito $creditoRepository,
        protected Repository\Venta\Pago $pagoRepository,
        protected Repository\Venta\TipoPago $tipoPagoRepository,
        protected Repository\Venta\EstadoPago $estadoPagoRepository,
        protected Repository\Venta\TipoEstadoPago $tipoEstadoPagoRepository,
        protected Money $moneyService
    ) {
        parent::__construct($logger);
    }

    public function getByVenta(int $venta_id): Model\Venta\Credito
    {
        return $this->creditoRepository->fetchByVenta($venta_id);
    }

    public function add(array $data): Model\Venta\Credito
    {
        $fecha = new DateTimeImmutable($data['fecha']);
        $uf = $data['uf'] ?? $this->moneyService->getUF($fecha);
        $tipoPago = $this->tipoPagoRepository->fetchByDescripcion('carta de resguardo');
        $pago = $this->addPago(['fecha' => $fecha->format('Y-m-d'), 'valor' => $data['valor'] * $uf, 'uf' => $uf, 'tipo' => $tipoPago->id]);
        $credito = $this->creditoRepository->create([
            'valor' => $data['valor'],
            'fecha' => $fecha->format('Y-m-d'),
            'pago' => $pago->id
        ]);
        return $this->creditoRepository->save($credito);
    }
    public function edit(Model\Venta\Credito $credito, array $data): Model\Venta\Credito
    {
        $uf = $this->moneyService->getUF($credito->pago->fecha);
        if (array_key_exists('fecha', $data)) {
            $fecha = new DateTimeImmutable($data['fecha']);
            $data['fecha'] = $fecha->format('Y-m-d');
            $uf = $this->moneyService->getUF($fecha);
            $data['uf'] = $uf;
        }
        if (array_key_exists('valor', $data)) {
            $data['valor'] = round(((float) $data['valor']) * $uf);
        }
        $filteredData = array_intersect_key($data, array_fill_keys([
            'fecha',
            'uf',
            'valor',
            'banco'
        ], 0));
        $credito->pago = $this->pagoRepository->edit($credito->pago, $filteredData);
        return $this->creditoRepository->edit($credito, $filteredData);
    }
    protected function addPago(array $data): Model\Venta\Pago
    {
        $pago = $this->pagoRepository->create($data);
        $pago = $this->pagoRepository->save($pago);
        $tipoEstado = $this->tipoEstadoPagoRepository->fetchByDescripcion('no pagado');
        $data = [
            'pago' => $pago->id,
            'fecha' => $pago->fecha->format('Y-m-d'),
            'estado' => $tipoEstado->id
        ];
        $estado = $this->estadoPagoRepository->create($data);
        $this->estadoPagoRepository->save($estado);
        return $pago;
    }
}
